#10/02/2017 this code will reproduce the revision for Infancy

require(Hmisc)
require(lme4)
require(psych)
require(ggplot2)
require(car)
require(reshape)
source("remef.R")
require(lsr)
##########################################################################################
#Section 1: create data file, code stimuli, correct participant numbers###################
##########################################################################################

# #read in tab separated data files from Tobii Studio.
setwd("INSERT PATH TO rawdata folder HERE")
data1=read.table("10ltf01.tsv", sep="\t", head=TRUE)
data=data1
data$stimno = 99999
stimnovar = 0
for (i in 1:nrow(data)) { #for every row

  if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
      && data$MediaName[i-1] == data$MediaName[i] #and if the previous row is also a training trial
      && data$MediaName[i+1] == data$MediaName[i]) { #and if the next row is also a training trial

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
   else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg")
            && data$MediaName[i-1] == data$MediaName[i]
            && data$MediaName[i+1] != data$MediaName[i]) { #the final sample has the same medianame as the previous stim but a different name to the next stim

  data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

            }

  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
             && data$MediaName[i-2] != data$MediaName[i])#and if the previous row is not a training trial
  {

    stimnovar = stimnovar+1 #increment stimno variable beacuse it's the next stimulus
    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
}
data1=data

data2=read.table("10ltf03.tsv", sep="\t", head=TRUE)
data=data2
data$stimno = 99999
stimnovar = 0

for (i in 1:nrow(data)) { #for every row

  if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
      && data$MediaName[i-1] == data$MediaName[i] #and if the previous row is also a training trial
      && data$MediaName[i+1] == data$MediaName[i]) { #and if the next row is also a training trial

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg")
           && data$MediaName[i-1] == data$MediaName[i]
           && data$MediaName[i+1] != data$MediaName[i]) { #the final sample has the same medianame as the previous stim but a different name to the next stim

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }

  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
           && data$MediaName[i-2] != data$MediaName[i])#and if the previous row is not a training trial
  {

    stimnovar = stimnovar+1 #increment stimno variable beacuse it's the next stimulus
    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
}
data2=data

data3=read.table("10ltf04.tsv", sep="\t", head=TRUE)
data=data3
data$stimno = 99999
stimnovar = 0
for (i in 1:nrow(data)) { #for every row

  if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
      && data$MediaName[i-1] == data$MediaName[i] #and if the previous row is also a training trial
      && data$MediaName[i+1] == data$MediaName[i]) { #and if the next row is also a training trial

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg")
           && data$MediaName[i-1] == data$MediaName[i]
           && data$MediaName[i+1] != data$MediaName[i]) { #the final sample has the same medianame as the previous stim but a different name to the next stim

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }

  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
           && data$MediaName[i-2] != data$MediaName[i])#and if the previous row is not a training trial
  {

    stimnovar = stimnovar+1 #increment stimno variable beacuse it's the next stimulus
    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
}
data3=data

data4=read.table("10ltf06.tsv", sep="\t", head=TRUE)
data=data4
data$stimno = 99999
stimnovar = 0
for (i in 1:nrow(data)) { #for every row

  if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
      && data$MediaName[i-1] == data$MediaName[i] #and if the previous row is also a training trial
      && data$MediaName[i+1] == data$MediaName[i]) { #and if the next row is also a training trial

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg")
           && data$MediaName[i-1] == data$MediaName[i]
           && data$MediaName[i+1] != data$MediaName[i]) { #the final sample has the same medianame as the previous stim but a different name to the next stim

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }

  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
           && data$MediaName[i-2] != data$MediaName[i])#and if the previous row is not a training trial
  {

    stimnovar = stimnovar+1 #increment stimno variable beacuse it's the next stimulus
    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
}
data4=data

data5=read.table("10ltf06a.tsv", sep="\t", head=TRUE)
data=data5
data$stimno = 99999
stimnovar = 0
for (i in 1:nrow(data)) { #for every row

  if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
      && data$MediaName[i-1] == data$MediaName[i] #and if the previous row is also a training trial
      && data$MediaName[i+1] == data$MediaName[i]) { #and if the next row is also a training trial

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg")
           && data$MediaName[i-1] == data$MediaName[i]
           && data$MediaName[i+1] != data$MediaName[i]) { #the final sample has the same medianame as the previous stim but a different name to the next stim

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }

  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
           && data$MediaName[i-2] != data$MediaName[i])#and if the previous row is not a training trial
  {

    stimnovar = stimnovar+1 #increment stimno variable beacuse it's the next stimulus
    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
}
data5=data

data6=read.table("10ltf07.tsv", sep="\t", head=TRUE)
data=data6
data$stimno = 99999
stimnovar = 0
for (i in 1:nrow(data)) { #for every row

  if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
      && data$MediaName[i-1] == data$MediaName[i] #and if the previous row is also a training trial
      && data$MediaName[i+1] == data$MediaName[i]) { #and if the next row is also a training trial

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg")
           && data$MediaName[i-1] == data$MediaName[i]
           && data$MediaName[i+1] != data$MediaName[i]) { #the final sample has the same medianame as the previous stim but a different name to the next stim

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }

  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
           && data$MediaName[i-2] != data$MediaName[i])#and if the previous row is not a training trial
  {

    stimnovar = stimnovar+1 #increment stimno variable beacuse it's the next stimulus
    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
}
data6=data

data7=read.table("10ltf08.tsv", sep="\t", head=TRUE)
data=data7
data$stimno = 99999
stimnovar = 0
for (i in 1:nrow(data)) { #for every row

  if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
      && data$MediaName[i-1] == data$MediaName[i] #and if the previous row is also a training trial
      && data$MediaName[i+1] == data$MediaName[i]) { #and if the next row is also a training trial

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg")
           && data$MediaName[i-1] == data$MediaName[i]
           && data$MediaName[i+1] != data$MediaName[i]) { #the final sample has the same medianame as the previous stim but a different name to the next stim

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }

  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
           && data$MediaName[i-2] != data$MediaName[i])#and if the previous row is not a training trial
  {

    stimnovar = stimnovar+1 #increment stimno variable beacuse it's the next stimulus
    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
}
data7=data
#
data8=read.table("10ltf08a.tsv", sep="\t", head=TRUE)
data=data8
data$stimno = 99999
stimnovar = 0
for (i in 1:nrow(data)) { #for every row

  if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
      && data$MediaName[i-1] == data$MediaName[i] #and if the previous row is also a training trial
      && data$MediaName[i+1] == data$MediaName[i]) { #and if the next row is also a training trial

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg")
           && data$MediaName[i-1] == data$MediaName[i]
           && data$MediaName[i+1] != data$MediaName[i]) { #the final sample has the same medianame as the previous stim but a different name to the next stim

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }

  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
           && data$MediaName[i-2] != data$MediaName[i])#and if the previous row is not a training trial
  {

    stimnovar = stimnovar+1 #increment stimno variable beacuse it's the next stimulus
    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
}
data8=data
#
data9=read.table("10ltf09a.tsv", sep="\t", head=TRUE)
data=data9
data$stimno = 99999
stimnovar = 0
for (i in 1:nrow(data)) { #for every row

  if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
      && data$MediaName[i-1] == data$MediaName[i] #and if the previous row is also a training trial
      && data$MediaName[i+1] == data$MediaName[i]) { #and if the next row is also a training trial

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg")
           && data$MediaName[i-1] == data$MediaName[i]
           && data$MediaName[i+1] != data$MediaName[i]) { #the final sample has the same medianame as the previous stim but a different name to the next stim

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }

  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
           && data$MediaName[i-2] != data$MediaName[i])#and if the previous row is not a training trial
  {

    stimnovar = stimnovar+1 #increment stimno variable beacuse it's the next stimulus
    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
}
data9=data
#
data10=read.table("10ltf10.tsv", sep="\t", head=TRUE)
data=data10
data$stimno = 99999
stimnovar = 0
for (i in 1:nrow(data)) { #for every row

  if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
      && data$MediaName[i-1] == data$MediaName[i] #and if the previous row is also a training trial
      && data$MediaName[i+1] == data$MediaName[i]) { #and if the next row is also a training trial

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg")
           && data$MediaName[i-1] == data$MediaName[i]
           && data$MediaName[i+1] != data$MediaName[i]) { #the final sample has the same medianame as the previous stim but a different name to the next stim

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }

  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
           && data$MediaName[i-2] != data$MediaName[i])#and if the previous row is not a training trial
  {

    stimnovar = stimnovar+1 #increment stimno variable beacuse it's the next stimulus
    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
}
data10=data

data11=read.table("10ltf12.tsv", sep="\t", head=TRUE)
data=data11
data$stimno = 99999
stimnovar = 0
for (i in 1:nrow(data)) { #for every row

  if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
      && data$MediaName[i-1] == data$MediaName[i] #and if the previous row is also a training trial
      && data$MediaName[i+1] == data$MediaName[i]) { #and if the next row is also a training trial

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg")
           && data$MediaName[i-1] == data$MediaName[i]
           && data$MediaName[i+1] != data$MediaName[i]) { #the final sample has the same medianame as the previous stim but a different name to the next stim

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }

  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
           && data$MediaName[i-2] != data$MediaName[i])#and if the previous row is not a training trial
  {

    stimnovar = stimnovar+1 #increment stimno variable beacuse it's the next stimulus
    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
}
data11=data
#
data12=read.table("10ltm02.tsv", sep="\t", head=TRUE)
data=data12
data$stimno = 99999
stimnovar = 0
for (i in 1:nrow(data)) { #for every row

  if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
      && data$MediaName[i-1] == data$MediaName[i] #and if the previous row is also a training trial
      && data$MediaName[i+1] == data$MediaName[i]) { #and if the next row is also a training trial

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg")
           && data$MediaName[i-1] == data$MediaName[i]
           && data$MediaName[i+1] != data$MediaName[i]) { #the final sample has the same medianame as the previous stim but a different name to the next stim

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }

  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
           && data$MediaName[i-2] != data$MediaName[i])#and if the previous row is not a training trial
  {

    stimnovar = stimnovar+1 #increment stimno variable beacuse it's the next stimulus
    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
}
data12=data
#
data13=read.table("10ltm03.tsv", sep="\t", head=TRUE)
data=data13
data$stimno = 99999
stimnovar = 0
for (i in 1:nrow(data)) { #for every row

  if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
      && data$MediaName[i-1] == data$MediaName[i] #and if the previous row is also a training trial
      && data$MediaName[i+1] == data$MediaName[i]) { #and if the next row is also a training trial

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg")
           && data$MediaName[i-1] == data$MediaName[i]
           && data$MediaName[i+1] != data$MediaName[i]) { #the final sample has the same medianame as the previous stim but a different name to the next stim

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }

  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
           && data$MediaName[i-2] != data$MediaName[i])#and if the previous row is not a training trial
  {

    stimnovar = stimnovar+1 #increment stimno variable beacuse it's the next stimulus
    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
}
data13=data
#
data14=read.table("10ltm06.tsv", sep="\t", head=TRUE)
data=data14
data$stimno = 99999
stimnovar = 0
for (i in 1:nrow(data)) { #for every row

  if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
      && data$MediaName[i-1] == data$MediaName[i] #and if the previous row is also a training trial
      && data$MediaName[i+1] == data$MediaName[i]) { #and if the next row is also a training trial

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg")
           && data$MediaName[i-1] == data$MediaName[i]
           && data$MediaName[i+1] != data$MediaName[i]) { #the final sample has the same medianame as the previous stim but a different name to the next stim

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }

  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
           && data$MediaName[i-2] != data$MediaName[i])#and if the previous row is not a training trial
  {

    stimnovar = stimnovar+1 #increment stimno variable beacuse it's the next stimulus
    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
}
data14=data
#
data15=read.table("10ltm07.tsv", sep="\t", head=TRUE)
data=data15
data$stimno = 99999
stimnovar = 0
for (i in 1:nrow(data)) { #for every row

  if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
      && data$MediaName[i-1] == data$MediaName[i] #and if the previous row is also a training trial
      && data$MediaName[i+1] == data$MediaName[i]) { #and if the next row is also a training trial

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg")
           && data$MediaName[i-1] == data$MediaName[i]
           && data$MediaName[i+1] != data$MediaName[i]) { #the final sample has the same medianame as the previous stim but a different name to the next stim

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }

  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
           && data$MediaName[i-2] != data$MediaName[i])#and if the previous row is not a training trial
  {

    stimnovar = stimnovar+1 #increment stimno variable beacuse it's the next stimulus
    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
}
data15=data
#
data16=read.table("10ltm08.tsv", sep="\t", head=TRUE)
data=data16
data$stimno = 99999
stimnovar = 0
for (i in 1:nrow(data)) { #for every row

  if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
      && data$MediaName[i-1] == data$MediaName[i] #and if the previous row is also a training trial
      && data$MediaName[i+1] == data$MediaName[i]) { #and if the next row is also a training trial

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg")
           && data$MediaName[i-1] == data$MediaName[i]
           && data$MediaName[i+1] != data$MediaName[i]) { #the final sample has the same medianame as the previous stim but a different name to the next stim

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }

  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
           && data$MediaName[i-2] != data$MediaName[i])#and if the previous row is not a training trial
  {

    stimnovar = stimnovar+1 #increment stimno variable beacuse it's the next stimulus
    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
}
data16=data
#
data17=read.table("10ltm09.tsv", sep="\t", head=TRUE)
data=data17
data$stimno = 99999
stimnovar = 0
for (i in 1:nrow(data)) { #for every row

  if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
      && data$MediaName[i-1] == data$MediaName[i] #and if the previous row is also a training trial
      && data$MediaName[i+1] == data$MediaName[i]) { #and if the next row is also a training trial

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg")
           && data$MediaName[i-1] == data$MediaName[i]
           && data$MediaName[i+1] != data$MediaName[i]) { #the final sample has the same medianame as the previous stim but a different name to the next stim

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }

  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
           && data$MediaName[i-2] != data$MediaName[i])#and if the previous row is not a training trial
  {

    stimnovar = stimnovar+1 #increment stimno variable beacuse it's the next stimulus
    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
}
data17=data
#
data18=read.table("10ltm11.tsv", sep="\t", head=TRUE)
data=data18
data$stimno = 99999
stimnovar = 0
for (i in 1:nrow(data)) { #for every row

  if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
      && data$MediaName[i-1] == data$MediaName[i] #and if the previous row is also a training trial
      && data$MediaName[i+1] == data$MediaName[i]) { #and if the next row is also a training trial

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg")
           && data$MediaName[i-1] == data$MediaName[i]
           && data$MediaName[i+1] != data$MediaName[i]) { #the final sample has the same medianame as the previous stim but a different name to the next stim

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }

  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
           && data$MediaName[i-2] != data$MediaName[i])#and if the previous row is not a training trial
  {

    stimnovar = stimnovar+1 #increment stimno variable beacuse it's the next stimulus
    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
}
data18=data

data19=read.table("10ltm12.tsv", sep="\t", head=TRUE)
data=data19
data$stimno = 99999
stimnovar = 0
for (i in 1:nrow(data)) { #for every row

  if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
      && data$MediaName[i-1] == data$MediaName[i] #and if the previous row is also a training trial
      && data$MediaName[i+1] == data$MediaName[i]) { #and if the next row is also a training trial

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg")
           && data$MediaName[i-1] == data$MediaName[i]
           && data$MediaName[i+1] != data$MediaName[i]) { #the final sample has the same medianame as the previous stim but a different name to the next stim

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }

  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
           && data$MediaName[i-2] != data$MediaName[i])#and if the previous row is not a training trial
  {

    stimnovar = stimnovar+1 #increment stimno variable beacuse it's the next stimulus
    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
}
data19=data
#
data20=read.table("10ltm13.tsv", sep="\t", head=TRUE)
data=data20
data$stimno = 99999
stimnovar = 0
for (i in 1:nrow(data)) { #for every row

  if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
      && data$MediaName[i-1] == data$MediaName[i] #and if the previous row is also a training trial
      && data$MediaName[i+1] == data$MediaName[i]) { #and if the next row is also a training trial

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg")
           && data$MediaName[i-1] == data$MediaName[i]
           && data$MediaName[i+1] != data$MediaName[i]) { #the final sample has the same medianame as the previous stim but a different name to the next stim

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }

  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
           && data$MediaName[i-2] != data$MediaName[i])#and if the previous row is not a training trial
  {

    stimnovar = stimnovar+1 #increment stimno variable beacuse it's the next stimulus
    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
}
data20=data

data21=read.table("10ltm14.tsv", sep="\t", head=TRUE)
data=data21
data$stimno = 99999
stimnovar = 0
for (i in 1:nrow(data)) { #for every row

  if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
      && data$MediaName[i-1] == data$MediaName[i] #and if the previous row is also a training trial
      && data$MediaName[i+1] == data$MediaName[i]) { #and if the next row is also a training trial

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg")
           && data$MediaName[i-1] == data$MediaName[i]
           && data$MediaName[i+1] != data$MediaName[i]) { #the final sample has the same medianame as the previous stim but a different name to the next stim

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }

  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
           && data$MediaName[i-2] != data$MediaName[i])#and if the previous row is not a training trial
  {

    stimnovar = stimnovar+1 #increment stimno variable beacuse it's the next stimulus
    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
}
data21=data
#
data22=read.table("10ltm15.tsv", sep="\t", head=TRUE)
data=data22
data$stimno = 99999
stimnovar = 0
for (i in 1:nrow(data)) { #for every row

  if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
      && data$MediaName[i-1] == data$MediaName[i] #and if the previous row is also a training trial
      && data$MediaName[i+1] == data$MediaName[i]) { #and if the next row is also a training trial

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg")
           && data$MediaName[i-1] == data$MediaName[i]
           && data$MediaName[i+1] != data$MediaName[i]) { #the final sample has the same medianame as the previous stim but a different name to the next stim

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }

  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
           && data$MediaName[i-2] != data$MediaName[i])#and if the previous row is not a training trial
  {

    stimnovar = stimnovar+1 #increment stimno variable beacuse it's the next stimulus
    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
}
data22=data
#
data23=read.table("10ltm16.tsv", sep="\t", head=TRUE)
data=data23
data$stimno = 99999
stimnovar = 0
for (i in 1:nrow(data)) { #for every row

  if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
      && data$MediaName[i-1] == data$MediaName[i] #and if the previous row is also a training trial
      && data$MediaName[i+1] == data$MediaName[i]) { #and if the next row is also a training trial

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg")
           && data$MediaName[i-1] == data$MediaName[i]
           && data$MediaName[i+1] != data$MediaName[i]) { #the final sample has the same medianame as the previous stim but a different name to the next stim

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }

  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
           && data$MediaName[i-2] != data$MediaName[i])#and if the previous row is not a training trial
  {

    stimnovar = stimnovar+1 #increment stimno variable beacuse it's the next stimulus
    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
}
data23=data
#
data24=read.table("10ltm17.tsv", sep="\t", head=TRUE)
data=data24
data$stimno = 99999
stimnovar = 0
for (i in 1:nrow(data)) { #for every row

  if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
      && data$MediaName[i-1] == data$MediaName[i] #and if the previous row is also a training trial
      && data$MediaName[i+1] == data$MediaName[i]) { #and if the next row is also a training trial

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg")
           && data$MediaName[i-1] == data$MediaName[i]
           && data$MediaName[i+1] != data$MediaName[i]) { #the final sample has the same medianame as the previous stim but a different name to the next stim

    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }

  else if (data$MediaName[i] %in% c("bluecasttobii.jpg","bluecherrytobii.jpg","redcasttobii.jpg","redcherrytobii.jpg") #if it's a training trial
           && data$MediaName[i-2] != data$MediaName[i])#and if the previous row is not a training trial
  {

    stimnovar = stimnovar+1 #increment stimno variable beacuse it's the next stimulus
    data$stimno[i] = stimnovar #label the stimulus number with the value of stimnovar

  }
}
data24=data

#correct participant numbers entered incorrectly in Tobii Studio
head(data4)
data4$ParticipantName="f05"
head(data4)

head(data24)
data24$ParticipantName="m17"
head(data24)

head(data8)
data8$ParticipantName="f08a"
head(data8)

alldata=rbind(data1,data2)
alldata=rbind(alldata,data3)
alldata=rbind(alldata,data4)
alldata=rbind(alldata,data5)
alldata=rbind(alldata,data6)
alldata=rbind(alldata,data7)
alldata=rbind(alldata,data8)
alldata=rbind(alldata,data9)
alldata=rbind(alldata,data10)
alldata=rbind(alldata,data11)
alldata=rbind(alldata,data12)
alldata=rbind(alldata,data13)
alldata=rbind(alldata,data14)
alldata=rbind(alldata,data15)
alldata=rbind(alldata,data16)
alldata=rbind(alldata,data17)
alldata=rbind(alldata,data18)
alldata=rbind(alldata,data19)
alldata=rbind(alldata,data20)
alldata=rbind(alldata,data21)
alldata=rbind(alldata,data22)
alldata=rbind(alldata,data23)
alldata=rbind(alldata,data24)

data= alldata

data$X = NULL #get rid of column we don't need

colnames(data) = c("order","pnum","recnum","recdate","stim","stimwidth","stimheight","timestamp","gazepointindex","gazex","gazey","lefteyevalid","righteyevalid","stimno") #make friendly column names

head(data)

xtabs(~pnum, data)#need 24 elements
xtabs(~order, data)#orders 1,2,3,4,13,14,15,16 tested twice, orders 5,6,7,8,9,10,11,12 tested once
xtabs(~stim,data)

#create a column that tells you what the target is
data$labelledobj = NA
data$labelledobj[data$order == 1] = "redcherry"
data$labelledobj[data$order == 2] = "redcherry"
data$labelledobj[data$order == 3] = "bluecherry"
data$labelledobj[data$order == 4] = "bluecherry"
data$labelledobj[data$order == 5] = "redcast"
data$labelledobj[data$order == 6] = "redcast"
data$labelledobj[data$order == 7] = "bluecast"
data$labelledobj[data$order == 8] = "bluecast"
data$labelledobj[data$order == 9] = "redcherry"
data$labelledobj[data$order == 10] = "redcherry"
data$labelledobj[data$order == 11] = "bluecherry"
data$labelledobj[data$order == 12] = "bluecherry"
data$labelledobj[data$order == 13] = "redcast"
data$labelledobj[data$order == 14] = "redcast"
data$labelledobj[data$order == 15] = "bluecast"
data$labelledobj[data$order == 16] = "bluecast"

data$testtargetside = NA #create column which tells you the side of the test target
data$testtargetside[data$order == 1] = "left"
data$testtargetside[data$order == 2] = "left"
data$testtargetside[data$order == 3] = "left"
data$testtargetside[data$order == 4] = "left"
data$testtargetside[data$order == 5] = "right"
data$testtargetside[data$order == 6] = "right"
data$testtargetside[data$order == 7] = "right"
data$testtargetside[data$order == 8] = "right"
data$testtargetside[data$order == 9] = "right"
data$testtargetside[data$order == 10] = "right"
data$testtargetside[data$order == 11] = "right"
data$testtargetside[data$order == 12] = "right"
data$testtargetside[data$order == 13] = "left"
data$testtargetside[data$order == 14] = "left"
data$testtargetside[data$order == 15] = "left"
data$testtargetside[data$order == 16] = "left"

head(data)

#make a column which lists whether the stimulus on screen is the labelled object or not
#make a friendly stimulus column
data$objonscreen = 99999
data$objonscreen[data$stim == "bluecasttobii.jpg"] = "bluecast"
data$objonscreen[data$stim == "redcasttobii.jpg"] = "redcast"
data$objonscreen[data$stim == "bluecherrytobii.jpg"] = "bluecherry"
data$objonscreen[data$stim == "redcherrytobii.jpg"] = "redcherry"
data$objonscreen[data$stim == "testRedCherryBlueCastTobii.wmv"] = "redcherrybluecast"
data$objonscreen[data$stim == "testBlueCherryRedCastTobii.wmv"] = "bluecherryredcast"
data$objonscreen[data$stim == "testBlueCastRedCherryTobii.wmv"] = "bluecastredcherry"
data$objonscreen[data$stim == "testRedCastBlueCherryTobii.wmv"] = "redcastbluecherry"
data$objonscreen[data$stim == "ba567b05-4abd-486b-b3e5-ce7f413e3784.avi"] = "ag"

data$stim=NULL

#tidy up superfluous columns and make more sensible column names
head(data)
data$X=NULL
data$X.1=NULL
colnames(data)#CHECK there are no X.x columns (these get added when you save a csv file in excel then read it into R)

write.csv(data, "labeltime_dataraw")

#get rid of invalid data (data where validity code is 4 for both left and right eye - means no eyes found)
data$valid = NA
data$valid = data$lefteyevalid+data$righteyevalid
dataraw=data
rawsamples = nrow(dataraw)
data=subset(dataraw, data$valid < 8)
goodsamples = nrow(data)
badsamples = rawsamples - goodsamples
propbadsamples = badsamples/rawsamples#number of bad samples where tracker couldn't detect any eyes
write.csv(data,"labeltime_dataclean.csv")

###########################################################################################
#Section 2: data cleaning, code fixed effects##############################################
###########################################################################################

data=read.csv("labeltime_dataclean.csv") #read in data
data$X=NULL

#familiarisation data#####
datafam=subset(data, objonscreen %in% c("bluecast","redcast","bluecherry","redcherry")) #take familiarisation data only
xtabs(~objonscreen, datafam) #shound only have values in "bluecast","redcast","bluecherry","redcherry" - these are the training trials
datafam$objonscreen=as.factor(as.character(datafam$objonscreen)) #only training trials
levels(datafam$objonscreen) #get rid of unnecessary factors
datafam$label=0
head(datafam)

#mark whether the on-screen object was label trained or not
#objonscreen is the object being displayed on that trial, labelledobj is the object that had a label during training. So, if labelledobj is the same as objonscreen, then the labelled object is being displayed
datafam$dispobjlabobj=paste(datafam$objonscreen, datafam$labelledobj, sep = "")
head(datafam)
datafam$label=NA
datafam$label=ifelse(datafam$dispobjlabobj %in% c("redcherryredcherry", "bluecherrybluecherry","redcastredcast", "bluecastbluecast"), 1,0) #if what's on screen matches what was trained, code 1, otherwise code 0
xtabs(~label+pnum, datafam) #these will not be equal numbers because we've removed invalid trials
xtabs(~objonscreen, datafam)
xtabs(~labelledobj + objonscreen, datafam) #there should only be values for samecolour/sameobj pairs, or oppositcolor/oppositeobj pairs (e.g. blucast+bluecast, bluecast + redcherry, not bluecase/bluecherry or bluecast/redcast)

#AOI looking. make AOI co-ordinates as per Tobii Studio (see aois-summary.xlsx)
stim=c("redcherry","redcast","bluecherry","bluecast")
xmax=c(1072,1164,1010,1140)
xmin=c(361,329,426,331)
ymax=c(1014,1021,1014,1016)
ymin=c(82,53,104,58)
aois=data.frame(stim,xmax,xmin,ymax,ymin)

datafam$aoihit = 0 #make column which will be 0 for non-AOI looking (1 for AOI looking)
head(datafam,100)

#gazex and gazey are sometimes NA (when tracker has eyes, but fixation is outside screen). NA is a logical value, but you need a numeric value to do the next bit; so change NA to 99999 so you can exclude them from being marked
datafam$gazex = recode(datafam$gazex, "NA=99999")
datafam$gazey = recode(datafam$gazey, "NA=99999")

datafam$aoihit=NA

#code red cherry (slightly different AOIs for each stim)
for (i in 1:nrow(datafam)) {
  if (datafam$gazex[i] != 99999 & datafam$gazey[i] != 99999 & datafam$objonscreen[i] == "redcherry" & datafam$gazex[i] >= aois$xmin[1] & datafam$gazex[i]<= aois$xmax[1] & datafam$gazey[i] >= aois$ymin[1] & datafam$gazey[i] <= aois$ymax[1]) {
    datafam$aoihit[i] = 1
  }
}

#code blue cherry
for (i in 1:nrow(datafam)) {
  if (datafam$gazex[i] != 99999 & datafam$gazey[i] != 99999 & datafam$objonscreen[i] == "bluecherry" & datafam$gazex[i] >= aois$xmin[3] & datafam$gazex[i]<= aois$xmax[3] & datafam$gazey[i] >= aois$ymin[3] & datafam$gazey[i] <= aois$ymax[3]) {
    datafam$aoihit[i] = 1
  }
}

#code red castanet
for (i in 1:nrow(datafam)) {
  if (datafam$gazex[i] != 99999 & datafam$gazey[i] != 99999 & datafam$objonscreen[i] == "redcast" & datafam$gazex[i] >= aois$xmin[2] & datafam$gazex[i]<= aois$xmax[2] & datafam$gazey[i] >= aois$ymin[2] & datafam$gazey[i] <= aois$ymax[2]) {
    datafam$aoihit[i] = 1
  }
}

#code blue castanet
for (i in 1:nrow(datafam)) {
  if (datafam$gazex[i] != 99999 & datafam$gazey[i] != 99999 & datafam$objonscreen[i] == "bluecast" & datafam$gazex[i] >= aois$xmin[4] & datafam$gazex[i]<= aois$xmax[4] & datafam$gazey[i] >= aois$ymin[4] & datafam$gazey[i] <= aois$ymax[4]) {
    datafam$aoihit[i] = 1
  }
}

xtabs(~aoihit + objonscreen, datafam)
datafam$objonscreen=as.factor(as.character(datafam$objonscreen))

#code aoilook (1) v backgroundlook (0) v no-look (-1)
datafam$Looktype= "background"
datafam$Looktype[datafam$gazex == 99999] = "offscreen"#gazex and gazey are 99999 when the tracker has the eye but the look is offscreen
datafam$Looktype[datafam$gazey == 99999] = "offscreen"
datafam$Looktype[datafam$aoihit == 1] = "aoihit"
xtabs(~Looktype, datafam)

datafam$label=as.factor(as.character(datafam$label))
levels(datafam$label)

xtabs(~ Looktype + stimno + label, datafam)#check there's no gaps
head(datafam)

write.csv(datafam, "labeltime_datafam.csv")

#test data#############

#aois for test trials
testcorners=c("1l","2l","3l","4l","1r","2r","3r","4r")
teststimAOI=c("left","left","left","left","right","right","right","right")
testxcoords=c(0,960,960,0,961,1920,1920,961)
testycoords=c(100,100,980,980,100,100,980,980)

testaois=data.frame(teststimAOI, testcorners, testxcoords, testycoords)
testaois

#code aoi hits first
datatest=subset(data, objonscreen %in% c("bluecastredcherry", "redcherrybluecast","redcastbluecherry","bluecherryredcast"))
datatest$objonscreen=as.factor(as.character(datatest$objonscreen))
xtabs(~objonscreen, datatest)#should be 4 levels

datatest$gazex = recode(datatest$gazex, "NA=99999")
datatest$gazey = recode(datatest$gazey, "NA=99999")
datatest$aoihit = NA

testaois
#code left AOI
for (i in 1:nrow(datatest)) {
  if (datatest$gazex[i] != 99999 & datatest$gazey[i] != 99999 & datatest$gazex[i] >= testaois$testxcoords[1] & datatest$gazex[i]<= testaois$testxcoords[2] & datatest$gazey[i] >= testaois$testycoords[1] & datatest$gazey[i] <= testaois$testycoords[3]) {
    datatest$aoihit[i] = "left"
  }
}

#code right AOI
for (i in 1:nrow(datatest)) {
  if (datatest$gazex[i] != 99999 & datatest$gazey[i] != 99999 & datatest$gazex[i] >= testaois$testxcoords[5] & datatest$gazex[i]<= testaois$testxcoords[6] & datatest$gazey[i] >= testaois$testycoords[5] & datatest$gazey[i] <= testaois$testycoords[7]) {
    datatest$aoihit[i] = "right"
  }
}

#code target looks on left
xtabs(~aoihit, datatest)
datatest$targplushit=paste(datatest$aoihit, datatest$testtarget, sep = "")#aoihit tells you which (if any) AOI is being looked at; testtarget tells you the side the target is on. so a match means it's a target look
head(datatest)

datatest$targetlook=0
datatest$targetlook[datatest$targplushit == "leftleft"] = 1
datatest$targetlook[datatest$targplushit == "rightright"] = 1
xtabs(~targetlook, datatest)

#code test looking type

datatest$looktype="background"#NAs are background looks
datatest$looktype[datatest$targplushit %in% c("leftright", "rightleft")] = "nontargetlook"#nontarget looks
datatest$looktype[datatest$targplushit %in% c("leftleft", "rightright")] = "targetlook"
datatest$looktype[datatest$gazex == 99999] = "lookaway"
datatest$looktype[datatest$gazey == 99999] = "lookaway"

xtabs(~looktype, datatest)

head(datatest)

#plot gaze points to check test AOIs are correctly defined
p = ggplot(subset(datatest, looktype %nin% "lookaway"), aes(x=gazex, y=gazey,colour = aoihit))
p = p + geom_point(size =1)
p

#find first timestamp for each particpant, then time is just timestamp minus that number

datatest$count =1
ppts=aggregate(count ~ pnum, datatest, sum)
ppts

#make list of start times so we can calculate when the label was for each ppt. It's slightly different for each because the AG stops when the baby looks at it.
a=c("F01","164747")
b=c("F03","167851")
c=c("F04","169805")
d=c("f05","163779")
e=c("F06","164140")
f=c("F07","162816")
g=c("f08","166382")
h=c("F08","166302")
i=c("F09a","174147")
j=c("F10","167320")
k=c("f12","182744")
l=c("M02","180168")
m=c("M03","166831")
n=c("M06","179753")
o=c("m07","168218")
p=c("m08","176977")
q=c("m09","173986")
r=c("M11","164499")
s=c("m12","159164")
t=c("M13","166728")
u=c("M14","174426")
v=c("m15","165627")
w=c("m16","172757")
x=c("m17","179132")
times=rbind(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x)
times=as.data.frame(times)

head(datatest)

datatest$start[datatest$pnum == "F01"] = 164747
datatest$start[datatest$pnum == "F03"] = 167851
datatest$start[datatest$pnum == "F04"] = 169805
datatest$start[datatest$pnum == "f05"] = 163779
datatest$start[datatest$pnum == "F06"] = 164140
datatest$start[datatest$pnum == "F07"] = 162816
datatest$start[datatest$pnum == "f08"] = 166382
datatest$start[datatest$pnum == "F08"] = 166302
datatest$start[datatest$pnum == "F09a"] = 174147
datatest$start[datatest$pnum == "F10"] = 167320
datatest$start[datatest$pnum == "f12"] = 182744
datatest$start[datatest$pnum == "M02"] = 180168
datatest$start[datatest$pnum == "M03"] = 166831
datatest$start[datatest$pnum == "M06"] = 179753
datatest$start[datatest$pnum == "m07"] = 168218
datatest$start[datatest$pnum == "m08"] = 176977
datatest$start[datatest$pnum == "m09"] = 173986
datatest$start[datatest$pnum == "M11"] = 164499
datatest$start[datatest$pnum == "m12"] = 159164
datatest$start[datatest$pnum == "M13"] = 166728
datatest$start[datatest$pnum == "M14"] = 174426
datatest$start[datatest$pnum == "m15"] = 165627
datatest$start[datatest$pnum == "m16"] = 172757
datatest$start[datatest$pnum == "m17"] = 179132
datatest$time = datatest$timestamp - datatest$start

head(datatest,100)
tail(datatest, 100)

write.csv(datatest, "labeltime_datatest.csv")

###########################################################################################
#Section 3: Analyses#######################################################################
###########################################################################################


#preferential looking trial#####
datatestall=read.csv("labeltime_datatest.csv")
datatestall$bin=floor(1+(datatestall$time/50))#Borovsky et al 2015
head(datatestall)
xtabs(~bin, datatestall)
xtabs(~looktype,datatestall)

testaoidata=subset(datatestall, looktype %in% c("nontargetlook","targetlook"))#only want screen looking

totalsamples=nrow(datatestall)
aoilooksamples=nrow(testaoidata)
nonaoilooksamples=totalsamples-aoilooksamples
propdiscardedtest=nonaoilooksamples/totalsamples
propdiscardedtest#proportion of trials discarded because infants weren't looking at the screen

plotdatatest=summarySE(testaoidata, measurevar = "targetlook", groupvars=c("bin"))
meansall=aggregate(targetlook~ bin + pnum, testaoidata, mean)
xtabs(~pnum, testaoidata)

head(meansall)
meansall$bin = as.numeric(meansall$bin)
xtabs(~bin, meansall)


#pre- versus post-label looking#####Label onset tanzer 5171ms Label offset 6000ms

#a) looking between 233 and  2000ms after target onset Mani & Plunkett 2010. 5171+233 = 5404###
datatestpost = subset(testaoidata, time >= 5404 & time <= 7171)#7171
datatestpre = subset(testaoidata, time < 5404 & time >= 3404)
#one participant doesn't look post-test

#pre-label compared to chance
datatestpre=aggregate(targetlook ~ pnum, datatestpre, mean)
t.test(datatestpre$targetlook, mu = 0.5, alternative = "two.sided")
dpre =(mean(datatestpre$targetlook) - 0.5)/sd(datatestpre$targetlook)
dpre
sd(datatestpre$targetlook)

#post-label compared to chance
datatestpost=aggregate(targetlook ~ pnum, datatestpost, mean)
t.test(datatestpost$targetlook, mu = 0.5, alternative = "two.sided")
dpost =(mean(datatestpost$targetlook) - 0.5)/sd(datatestpost$targetlook)
dpost
sd(datatestpost$targetlook)

#increase in looking
datatestprepost=merge(datatestpre, datatestpost, by = "pnum", all.x=TRUE, all.y=TRUE)
datatestprepost$targetlook.x = recode(datatestprepost$targetlook.x, "NA=0")#two infants were looking away from the screen prelabeling, then reoriented after labeling
colnames(datatestprepost) = c("pnum", "targlookpre", "targlookpost")
t.test(datatestprepost$targlookpre, datatestprepost$targlookpost, paired=TRUE, alternative = "two.sided")

xtabs(~pnum, datatestpre)#F08a, F10, M14 no data
xtabs(~pnum, datatestpost)#F08a no data

head(datatestprepost)
datatestprepost$targlookpre = recode(datatestprepost$targlookpre, "NA=0")
datatestprepost$diff=datatestprepost$targlookpost - datatestprepost$targlookpre
datatestprepost <- datatestprepost[order(diff),]
datatestprepost$Participant=c("a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w")
datatestprepost <-  datatestprepost[order(datatestprepost$diff),]

datatestprepost$Participant=as.factor(datatestprepost$Participant)

diffplot=ggplot(datatestprepost, aes(y = diff, x = Participant))
diffplot = diffplot + geom_bar(stat = "identity", position = "dodge")
diffplot = diffplot + theme_bw()
diffplot#positive bars indicate shift to target. Note F08a didn't contribute
diffplot = diffplot + theme(legend.key = element_rect(colour="white"))
diffplot = diffplot + theme(panel.border= element_blank())
diffplot = diffplot + theme(axis.line=element_line(colour="black"))
diffplot = diffplot + theme(panel.grid.minor=element_blank(), panel.grid.major=element_blank())
diffplot = diffplot + theme(axis.line.x=element_line(colour="black"))
diffplot = diffplot + theme(axis.line.y=element_line(colour="black"))
diffplot = diffplot +  geom_hline(yintercept=c(0), linetype="dotted")
diffplot = diffplot + ylab("Change in proportion target looking\n") + xlab("\nParticipant")
diffplot = diffplot+ guides(fill = FALSE)
diffplot = diffplot  +ylim(-0.8, 0.8)
diffplot = diffplot + scale_y_continuous(breaks = c(-0.8,-0.7,-0.6,-0.5,-0.4,-0.3,-0.2,-0.1,0,0.1,0.2,0.3,0.4,0.5,0.6,0.7,0.8))
diffplot#positive bars indicate shift to target. Note F08a didn't contribute
#ggsave("difference scores.pdf", height= 4, width = 7)

#familiarization data###

datafam=read.csv("labeltime_datafam.csv")

#create df for raw looking with just screen looks in
datafam$trial=NA#code trial not stimno, so you've got a measure of what the first trial is per stimulus
datafam$trial = ceil(datafam$stimno/2)
datafam$Label=ifelse(datafam$label == 1, "Labelled", "Unlabelled")#make text column for plotting
datafam$label = as.factor(datafam$label)#check it's a factor
head(datafam)

datafamlooks=subset(datafam, Looktype != "offscreen")#take screen looking only
datafamlooks$look = ifelse(datafamlooks$Looktype == "aoihit", 1,0)#code aoi looks

nonlooks=nrow(datafam) - nrow(datafamlooks)
propnonlooksfam = nonlooks/nrow(datafam)
propnonlooksfam#gives you the proportion of trials excluded because infants weren't looking at the screen

head(datafamlooks)

write.csv(datafamlooks,"labeltime-data-fam-screenlooks.csv")

#add label responses to familiarization df#####

dataall=merge(datafamlooks, datatestprepost, by = "pnum", all.x = TRUE, all.y = TRUE)#need all.x/y = TRUE to keep in data for f08a, who doesn't look during the pre-post labelling phase, but does look during the test trial and familiarization
head(dataall)
xtabs(~diff, dataall)
is.numeric(dataall$diff)

#compare first 3000 ms of looking in pref looking trial to final 3000 ms of looking on final test trial. exclude looks away then use raw looking times to screen

datafinaltrial = subset(dataall, stimno  == 16)#not trial 8 because this is sometimes stimulus 15
#need to code the trial times
xtabs(~pnum, datafinaltrial)
colnames(datafinaltrial)
xtabs(~Looktype, datafinaltrial)
datafinaltrial$flag = 0

for (i in 2:nrow(datafinaltrial)) {
  if (i == 2) {datafinaltrial$trialtimetrue[i - 1] = 1
  datafinaltrial$trialtimetrue[i] = 18}
else if (datafinaltrial$pnum[i] != datafinaltrial$pnum[i-1]) {datafinaltrial$trialtimetrue[i] = 1
datafinaltrial$flag[i - 1] =1}
else if (datafinaltrial$pnum[i] == datafinaltrial$pnum[i-1]) {datafinaltrial$trialtimetrue[i] = datafinaltrial$trialtimetrue[i - 1]+17 }}

trialends=subset(datafinaltrial, flag == 1)
trialends$trialend=trialends$trialtimetrue
head(trialends)
colnames(trialends)
xtabs(~pnum,trialends)

trialends2=trialends[c(1, 32)]
colnames(trialends2)[2]="trialend"

datafinaltrial2=merge(datafinaltrial, trialends2, by = "pnum")
head(datafinaltrial2)
xtabs(~pnum, datafinaltrial2)
datafinaltrial2$timefromend=datafinaltrial2$trialend - datafinaltrial2$trialtimetrue
head(datafinaltrial2)
xtabs(~pnum, datafinaltrial2)

datafatiguefinal = subset(datafinaltrial2, timefromend <= 5171)
xtabs(~Looktype, datafatiguefinal)#no offscreen but everything else
datafatiguefinal$lookaoi=ifelse(datafatiguefinal$Looktype == "aoihit", 1, 0)#we want to know when they're looking at the AOI
xtabs(~lookaoi, datafatiguefinal)
head(datafatiguefinal,100)

datafatiguefinalT=aggregate(lookaoi ~ pnum, datafatiguefinal, mean)
xtabs(~pnum, datafatiguefinalT)#no data from m17

head(datafatiguefinalT)

#get first 3000 ms of pref looking trial
datafatiguetest = subset(datatestall, time > 0 & time <=5171 & looktype != "lookaway")#only want screen looks; aggregate by sum for raw looking times
xtabs(~ looktype, datafatiguetest)#no lookaway but everything else
datafatiguetest$lookaoi=ifelse(datafatiguetest$looktype == "background", 0, 1)
xtabs(~lookaoi, datafatiguetest)

head(datafatiguetest)
datafatiguetestT = aggregate(lookaoi ~ pnum, datafatiguetest, mean)

head(datafatiguetestT)

datafatiguefinalT=subset(datafatiguefinalT, pnum %nin% c("m17", "f08a"))
datafatiguetestT=subset(datafatiguetestT, pnum %nin% c("m17", "f08a"))

head(datafatiguefinalT)
head(datafatiguetestT)

t.test(datafatiguefinalT$lookaoi, datafatiguetestT$lookaoi, paired = TRUE)
describe(datafatiguefinalT$lookaoi)
describe(datafatiguetestT$lookaoi)

xtabs(~pnum, datafinaltrial)
xtabs(~pnum, datafinaltrial)

#mixed effects model
maxmodel = glmer(look ~  label + trial + diff + label:trial + label:diff + trial:diff + (1  | pnum) ,dataall, family = binomial)
summary(maxmodel)

labelmodel =  glmer(look ~  trial * diff + (1 | pnum), subset(dataall, label == 1), family = binomial)
summary(labelmodel) 

nolabelmodel =  glmer(look ~  trial * diff + (1 | pnum), subset(dataall, label == 0), family = binomial)
summary(nolabelmodel)

#plot interactions
plotdata=aggregate(look ~ diff + trial + label, dataall, sum)

quantile(plotdata$diff)

plotdata$Quartile = NA

plotdata$Quartile[plotdata$diff >= -0.56962025  & plotdata$diff < -0.08809524 ] = "Quartile 1"
plotdata$Quartile[plotdata$diff  >= -0.08809524  & plotdata$diff < 0.29489265] = "Quartile 2"
plotdata$Quartile[plotdata$diff  >= 0.29489265 & plotdata$diff <  0.48837209 ] = "Quartile 3"
plotdata$Quartile[plotdata$diff  >= 0.48837209 & plotdata$diff <  0.77358491 ] = "Quartile 4"

xtabs(~Quartile, plotdata)

plotdata$Quartile=as.factor(as.character(plotdata$Quartile))
plotdata2 = aggregate(look~ Quartile + trial + label, plotdata, mean)
plotdata2$looktime = plotdata2$look * 0.017
p = ggplot(subset(plotdata2, label == 1), aes(y = looktime, x = trial))
#p = p + geom_bar(stat = "identity", position = "dodge")
p = p + geom_line() + geom_point()
p = p + facet_wrap(~Quartile)
#p = p + geom_bar(position = "dodge")
p = p + theme_bw()
p = p + geom_smooth(se=FALSE, size = 0.5)
p
p = p + theme(legend.key = element_rect(colour="white"))
#p = p + theme(panel.border= element_blank())
#p = p + theme(axis.line=element_line(colour="black"))
p = p + theme(panel.grid.minor=element_blank(), panel.grid.major=element_blank())
#p = p + theme(axis.line.x=element_line(colour="black"))
#p = p + theme(axis.line.y=element_line(colour="black"))
p = p + theme(strip.background = element_rect(fill="white"))
p = p +  theme(legend.position="bottom")
p = p + theme(legend.position = "none")
p = p + ylab("Time (ms)") + xlab("Trial")
p
ggsave("fig4.pdf",  height= 7, width = 7)

#plot familiar looking time



datafamlooks$look2=remef(maxmodel, ran = "all")#takes out random variation for error bars

head(datafamlooks, 30)

datafammeanspnum = aggregate(look ~  Label + trial + pnum, datafamlooks, sum)#looking times for participants by trial and cond
datafammeanspnum$Time = datafammeanspnum$look*17
head(datafammeanspnum)


datafammeanserrorbar = aggregate(look ~  Label + trial + pnum, datafamlooks, sum)
#looking time plots

source("summarySE.R")#loads r script that calculates 95% CIs
plotdata=summarySE(datafammeanspnum, measurevar = "Time", groupvars=c("Label", "trial"))
plotdata$Label=as.factor(plotdata$Label)
plotdata$Label2=ifelse(plotdata$Label == "Labelled", "Labeled", "Unlabeled")
plotdata$Label=plotdata$Label2
plotdata$Label2=NULL

errorbars=summarySE(datafammeanserrorbar, measurevar = "look2", groupvars = c("Label", "trial"))
plotdata$look2=errorbars$look2
plotdata$ci=errorbars$ci

require(ggplot2)
p = ggplot(plotdata, aes(x = trial, y = Time, linetype = Label, shape = Label))
p = p + geom_line() + geom_point()
p = p + theme_bw()
p = p + theme(panel.grid.minor=element_blank(), panel.grid.major=element_blank())
p = p + xlab("Trial") + ylab("Time (ms)")
p = p + theme(panel.border= element_blank())
p = p + theme(axis.line=element_line(colour="black"))
p = p+theme(legend.position="bottom")
p = p + scale_color_brewer()
p = p + geom_errorbar(aes(ymin=Time-ci, ymax=Time+ci),size=.3, width=.2)
p = p + theme(axis.line.x=element_line(colour="black"))
p = p + theme(axis.line.y=element_line(colour="black"))
p = p+ theme(legend.key = element_rect(colour = 'white', fill = 'white'))
p = p + guides(linetype=guide_legend(title=NULL))
p = p + guides(shape=guide_legend(title=NULL))
p
# ggsave("labeltime-rawlooking.pdf", height = 4, width = 6)

#add up number of rows where look = 1 for each participant by label and trial. Each row is a 17ms timestamp, so sum(looks)*17 gives total looking time.
descriptives=melt(datafammeanspnum, id=c("trial","pnum", "Label"))
head(descriptives)
desc2=cast(descriptives, variable + pnum ~ trial + Label, mean)
desc2 #THIS GIVES LOOKING TIMES DATAFRAME BY PARTICIPANT AND LABEL
descriptives=stat.desc(desc2) #copied into descriptives.csv
write.csv(descriptives, "descriptives.csv")

aggregate(look~label, datafamlooks, mean)#more looking to the labeled object
